from PyQt5 import QtCore, QtGui, QtWidgets
from .catsgse_tabs import Ui_TabWidget
import sys


# ------------------------------------------------------------------------------
#           GSE_MainApplication
# ------------------------------------------------------------------------------

class GSE_MainApplication(QtWidgets.QApplication):

    def __init__(self):

        super().__init__(sys.argv)
        self.tab_widget = QtWidgets.QTabWidget()
        self.ui = Ui_TabWidget()
        self.ui.setupUi(self.tab_widget)
        self.tab_widget.show()

    # ------------------------------------------------------------------------------
    #           notify
    # ------------------------------------------------------------------------------

    def notify(self, receiver: QtCore.QObject, event: QtCore.QEvent):
        """
        Implements the event notify that includes checking for the User defined events that come from
        the GSE code when it is asynchronously reading the HTML code from the 
        :param receiver: 
        :param event: 
        :return: 
        """
        if event.type() > QtCore.QEvent.User:
            w = receiver
            while (w):
                # Note that this calls `event` method directly thus bypassing
                # calling qApplications and receivers event filters
                res = w.event(event)
                if res and event.isAccepted():
                    return res
                w = w.parent()
        return super().notify(receiver, event)
